#include <stdio.h>
#include <stdlib.h>
#include "structures.h"
#include "classe.h"
#include "case.h"
#include "terrain.h"
#include "SDL.h"
#include "roxml.h"
#include "carte.h"
#include "Interface.h"


/*!
 * \fn int init_jeu(char *filename)
 * \brief Fonction d'initialisation du jeu
 *
 * \param Le fichier d'initialisation
 * \return un entier
 */
int init_jeu(char *filename)
{
    FILE *fichier_init;
    fichier_init=fopen(filename,"r");
    if (fichier_init!=NULL)
    {
        node_t *rootXML, *ConfigXML, *Classes, *Terrains;
        char nom[20];
        int i=0, nombre_config=0;

        rootXML = roxml_load_doc(filename);
        ConfigXML = roxml_get_chld(rootXML, NULL, 0);
        nombre_config = roxml_get_chld_nb(ConfigXML);

        for(i=0; i<nombre_config; i++)
        {
            node_t* config_actuelle = roxml_get_chld(ConfigXML, NULL, i);
            roxml_get_name(config_actuelle, nom, 20);

            if(strcmp(nom,"Classes")==0)
            {
                char fichier_text[50];
                char fichier_temp[50];
                strcpy(fichier_text,"../resources/");
                strcpy(fichier_temp,roxml_get_content(roxml_get_attr(config_actuelle, "fichier", 0), NULL, 0, NULL));
                strcat(fichier_text, fichier_temp);
                Librairie_Classes(fichier_text);
            }
            if(strcmp(nom,"Terrains")==0)
            {
                char fichier_text[50];
                char fichier_temp[50];
                strcpy(fichier_text,"../resources/");
                strcpy(fichier_temp,roxml_get_content(roxml_get_attr(config_actuelle, "fichier", 0), NULL, 0, NULL));
                strcat(fichier_text, fichier_temp);
                Librairie_Terrains(fichier_text);
            }
            if(strcmp(nom,"Cartes")==0)
            {
                char fichier_text[50];
                char fichier_temp[50];
                strcpy(fichier_text,"../resources/");
                strcpy(fichier_temp,roxml_get_content(roxml_get_attr(config_actuelle, "fichier", 0), NULL, 0, NULL));
                strcat(fichier_text, fichier_temp);
                char *Map_B = ExtraireCarte(2);
            }
            if(strcmp(nom,"Competences")==0)
            {
                /* Initialisation des comptences  venir */

            }
        }

        fclose(fichier_init);

    }
    else
    {
        fprintf(stderr,"Erreur dans l'ouverture du fichier");
        return 1;
    }
    return 0;
}


/*!
 * \fn Game_Package Construire_Package()
 * \brief Fonction de construction d'un package contenant l'univers du jeu
 *
 * \return un Game_Package
 */
Game_Package Construire_Package()
{
    Game_Package Pack;

    Classe* Classes_Pack = Librairie_Classes("../resources/Classes.xml");
    Terrain* Terrains_Pack = Librairie_Terrains("../resources/Terrains.xml");
    Skins_GUI* GUI_Pack = Get_Skins_GUI("../resources/GUI.xml");

    Pack.Classes_Package = Classes_Pack;
    Pack.Terrains_Package = Terrains_Pack;
    Pack.GUI_Package = GUI_Pack;

    return Pack;
}


int main()
{

//init_jeu("../resources/Init_jeu.xml");

    char *Map_A = ExtraireCarte(4);
    printf("Map en version texte : %s\n", Map_A);


    Game_Package Pack_A = Construire_Package();

    /* -------------------------------------*/
    /* Comment utiliser le package : */
    /* -------------------------------------*/

    printf("L'attaque 1 du mage est : %s\n",Pack_A.Classes_Package[0].attaques[0].nom);
    printf("Le nom du terrain 1 est : %s\n",Pack_A.Terrains_Package[0].nomTerrain);
    printf("L'adresse de la texture GUI 1 est : %s\n",Pack_A.GUI_Package[0].GUI_default);

    main_SDL(Map_A);

    Carte * c = nouvelleCarte();
    init_carte(c);

    return 0;
}
